#!/bin/bash

###############################################################################
# Linux Management Providers (LMP), Software Inventory provider package
# Copyright (C) 2009 Nazarov Nodir, TUIT <nazarov.nodir@gmail.com, nodir2000@yahoo.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################

if test "$3" = pegasus
then
	
	cimmof -aE -n $1 $6/mof/OpenDRIM_SoftwareIdentityResource.mof

	OUTFILE=./TEMP_REGISTRATION
	
cat >> $OUTFILE << EOFC
instance of PG_ProviderModule {
Caption = "OpenDRIM_SoftwareIdentityResource provider module";
Name = "SoftwareInventory_OpenDRIM_SoftwareIdentityResourceModule";
Location = "cmpiSoftwareInventory_OpenDRIM_SoftwareIdentityResourceProvider";
Vendor = "$2";
Version = "$5";
InterfaceType = "CMPI";
InterfaceVersion = "2.0.0";
};

instance of PG_Provider {
Caption = "OpenDRIM_SoftwareIdentityResource provider";
Name = "SoftwareInventory_OpenDRIM_SoftwareIdentityResourceProvider";
ProviderModuleName = "SoftwareInventory_OpenDRIM_SoftwareIdentityResourceModule";
};

instance of PG_ProviderCapabilities {
Caption = "OpenDRIM_SoftwareIdentityResource provider capabilities";
ProviderModuleName = "SoftwareInventory_OpenDRIM_SoftwareIdentityResourceModule";
ProviderName = "SoftwareInventory_OpenDRIM_SoftwareIdentityResourceProvider";
ClassName = "OpenDRIM_SoftwareIdentityResource";
ProviderType = {2, 5};
Namespaces = {"$1"};
SupportedProperties = {"Caption", "Description", "ElementName", "InstallDate", "OperationalStatus", "StatusDescriptions", "Status", "HealthState", "PrimaryStatus", "DetailedStatus", "OperatingStatus", "CommunicationStatus", "EnabledState", "OtherEnabledState", "RequestedState", "EnabledDefault", "TimeOfLastStateChange", "AvailableRequestedStates", "TransitioningToState", "SystemCreationClassName", "SystemName", "CreationClassName", "Name", "AccessInfo", "OtherInfoFormatDescription", "AccessContext", "OtherAccessContext", "InfoFormat", "ResourceType", "ExtendedResourceType", "OtherResourceType"};
SupportedMethods = {"RequestStateChange"};
CapabilityID = "SoftwareInventory_OpenDRIM_SoftwareIdentityResource";
};

EOFC
	
	cimmof -n root/PG_InterOp $OUTFILE
	
	rm -f $OUTFILE
	
fi

if test "$3" = sfcb
then
	
	OUTFILE=./OpenDRIM_SoftwareIdentityResource.reg
	
cat >> $OUTFILE <<EOFC
[OpenDRIM_SoftwareIdentityResource]   
   provider: SoftwareInventory_OpenDRIM_SoftwareIdentityResourceProvider
   location: cmpiSoftwareInventory_OpenDRIM_SoftwareIdentityResourceProvider
   type: instance method
   namespace: $1
#
EOFC
	
	sfcbstage -r $OUTFILE -n $1 $6/mof/OpenDRIM_SoftwareIdentityResource.mof
	
	rm -f $OUTFILE
	
	sfcbrepos -f
	
fi

if test "$3" = openwbem
then
	
	OUTFILE=./OpenDRIM_SoftwareIdentityResource-reg.mof
	rm -f $OUTFILE
	sed "s/Provider *( *\"cmpi:/Provider(\"cmpi::/g" < $6/mof/OpenDRIM_SoftwareIdentityResource.mof >> $OUTFILE
	owmofc -u http://localhost/$1 $OUTFILE
	
	rm -f $OUTFILE
	
fi
